Name: ocaml
Version: 2.04
Release: rtcg_3.rh%{rh_release}
Summary: The Objective Caml compiler and programming environment
Source0: ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}.tar.gz
Source1: ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}-refman.html.tar.gz
Source2: ftp://ftp.inria.fr/lang/caml-light/ocaml-%{version}-refman.ps.gz
Patch: ocaml-%{version}-ext_prof.patch
Patch1: ocaml-%{version}-interf.patch
Patch2: ocaml-%{version}-rtcg.patch
Copyright: part LGPL, part QPL
Group: Development/Languages
Vendor: INRIA Rocquencourt
URL: http://pauillac.inria.fr/caml/
BuildRoot: /tmp/ocaml-root

%description
Objective Caml is a high-level, strongly-typed, functional and
object-oriented programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler
and an optimizing native-code compiler), an interactive toplevel system,
Lex&Yacc tools, a replay debugger, and a comprehensive library.

%package emacs
Group: Development/Tools
Summary: Emacs mode for OCaml
Requires: ocaml = %{version}

%description emacs
Emacs mode files for Objective Caml language

%changelog
* Sat Feb 19 2000 Alexey Nogin <ayn2@cornell.edu>
[ocaml-2.04-2]
- Fixed the profiler patch

* Sun Nov 21 1999 Alexey Nogin <ayn2@cornell.edu>
[ocaml-2.03-1]
- Upgraded to ocaml-2.03
- Added symlinks ocamlc.opt and ocamlopt.opt

* Sun Oct 10 1999 Alexey Nogin <ayn2@cornell.edu>
[ocaml-2.02-2]
- Fixed a problem with asmcomp/interf.ml running out of string size limitation

* Tue Dec 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Do not include any /usr/lib/ocaml/*.ml files

* Fri Dec 11 1998 Alexey Nogin <ayn2@cornell.edu>
[ocaml-2.01-1]
- Updated to ocaml-2.01

* Sun Nov 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Divided ocaml RPM into ocaml and ocaml-emacs RPMs
  to make it easier to have both ocaml and caml installed
  on the same machine

* Wed Nov 10 1998 Alexey Nogin <ayn2@cornell.edu>
- Changed SRPM according to RHCN Package Requirements
- Added LICENSE, Changelog and README files to the doc directory

%prep
%setup -q -T -b 0
%setup -q -T -D -a 1
%patch -p0 -b .prof
%patch1 -p0
%patch2 -p1
cp %{SOURCE2} refman.ps.gz
./configure -bindir /usr/bin -libdir /usr/lib/ocaml -mandir /usr/man/man1 -with-pthread

%build
make world
make bootstrap
make world opt ocamlc.opt ocamlopt.opt

%install
rm -rf $RPM_BUILD_ROOT
echo BINDIR=$RPM_BUILD_ROOT/usr/bin >> config/Makefile
echo LIBDIR=$RPM_BUILD_ROOT/usr/lib/ocaml >> config/Makefile
echo MANDIR=$RPM_BUILD_ROOT/usr/man/man1 >> config/Makefile
make install
mv -f $RPM_BUILD_ROOT/usr/bin/ocamlc $RPM_BUILD_ROOT/usr/bin/ocamlc.byte
mv -f $RPM_BUILD_ROOT/usr/bin/ocamlc.opt $RPM_BUILD_ROOT/usr/bin/ocamlc
mv -f $RPM_BUILD_ROOT/usr/bin/ocamlopt $RPM_BUILD_ROOT/usr/bin/ocamlopt.byte
mv -f $RPM_BUILD_ROOT/usr/bin/ocamlopt.opt $RPM_BUILD_ROOT/usr/bin/ocamlopt
ln -s ocamlc $RPM_BUILD_ROOT/usr/bin/ocamlc.opt
ln -s ocamlopt $RPM_BUILD_ROOT/usr/bin/ocamlopt.opt
cp {parsing/{location,longident,parsetree},typing/typecore}.{cm,ml}i $RPM_BUILD_ROOT/usr/lib/ocaml
rm -f $RPM_BUILD_ROOT/usr/lib/ocaml/*.ml
(cd emacs; make install EMACSDIR=$RPM_BUILD_ROOT/usr/lib/emacs/site-lisp)

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/bin/ocaml
/usr/bin/ocamlc
/usr/bin/ocamlc.byte
/usr/bin/ocamlc.opt
/usr/bin/ocamlcp
/usr/bin/ocamldebug
/usr/bin/ocamldep
/usr/bin/ocamllex
/usr/bin/ocamlmktop
/usr/bin/ocamlopt
/usr/bin/ocamlprof
/usr/bin/ocamlopt.byte
/usr/bin/ocamlopt.opt
/usr/bin/ocamlrun
/usr/bin/ocamlyacc
/usr/lib/ocaml
/usr/man/man1/ocaml.1.gz
/usr/man/man1/ocamlc.1.gz
/usr/man/man1/ocamlcp.1.gz
/usr/man/man1/ocamldep.1.gz
/usr/man/man1/ocamllex.1.gz
/usr/man/man1/ocamlopt.1.gz
/usr/man/man1/ocamlprof.1.gz
/usr/man/man1/ocamlrun.1.gz
/usr/man/man1/ocamlyacc.1.gz
%doc refman.ps.gz htmlman LICENSE Changes README

%files emacs
%defattr(-,root,root)
/usr/lib/emacs/site-lisp/caml-font.el
/usr/lib/emacs/site-lisp/caml-hilit.el
/usr/lib/emacs/site-lisp/caml.el
/usr/lib/emacs/site-lisp/camldebug.el
/usr/lib/emacs/site-lisp/inf-caml.el
